#!/bin/sh 

#################################################################
#
# VirusScan for Mac Uninstall.command
# Copyright (c) 2008 McAfee, Inc. All Rights Reserved.
#
################################################################
delete()
{   
 if [ $# -ne 1 ] ; then
	echo "Invalid no of arguments passed to function delete "
	return
 fi
 if [ -s "${1}" ] ; then 
 sudo rm -rf "${1}"
 fi 
}
uninstallnwa()
{
if [ -s "/Library/NETAepoagt" ] ; then 
 sudo SystemStarter stop nwa
echo "removing nwa components"
for i in /Library/Receipts/NWA.pkg /Library/NETAepoagt /Library/StartupItems/nwa /Applications/Utilities/ePO\ Agent\ Configurator.app /Library/NETASSOC
  do
delete "$i"
done
fi 
}

deletelink()
{
 if [ $# -lt 1 ] ; then
	echo "Invalid no of arguments passed to function delete "
	return
 fi
 if [ -L "${1}" ] ; then 
 sudo rm -rf "${1}"
 fi 

}

killvirex77process()
{

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldBkgd" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShield" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldMount" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null


pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VirexLogin" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null


pid=`ps -ax -o "pid" -o "command" | grep -i "/Applications/Virex.app/Contents/MacOS/Virex" | grep -v grep | awk '{print $1}'`
sudo kill -1 ${pid} 2>/dev/null

 pid=`ps -ax -o "pid" -o "command" | grep -i "Virex Schedule Editor" | grep -v grep | awk '{print $1}'`
sudo kill -1 ${pid} 2>/dev/null

}

shutdownprocess()
{
# Kill Process after unloading from launchd 
echo "Shutting down VirusScan Daemons..."

pid=`ps -a -U root -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldScanManager" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null


pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/Applications/VirusScan.app/Contents/MacOS/VirusScan" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | grep "VShieldTaskManager" | grep -v grep | awk '{print $1}'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | grep "VirusScan Schedule Editor" | grep -v grep | awk '{print $1}'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | grep -i "/Library/Application Support/Virex/VirusScan Reporter" | grep -v grep | awk '{print $1}'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldScanner" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/Applications/Utilities/VirusScan" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "usr/local/vscanx/VirusScan" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

# kill the previous process
pid=`ps -a -U root -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldScan" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null


pid=`ps -a -U root -o "pid" -o "command" | awk -F " " '{ if ( $2 == "./VShieldEPOInterface" ) {print $1}  }'`
sudo kill -3 ${pid} 2>/dev/null
sudo kill -9 ${pid} 2>/dev/null

pid=`ps -a -U root -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldCheck" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -a -U root -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldCore" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null


pid=`ps -a -U root -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VShieldUpdate" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

pid=`ps -ax -o "pid" -o "command" | awk -F " " '{ if ( $2 == "/usr/local/vscanx/VirexLogin.app/Contents/MacOS/VirexLogin" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

#removing reporter
pid=`ps -ax -o "pid" -o "command" | awk '{ if ( $2$3 == "/Library/ApplicationSupport/Virex/VirusScan" ) {print $1}  }'`
sudo kill -1 ${pid} 2>/dev/null

sudo kextunload "/System/Library/Extensions/Virex.kext" 2>/dev/null
sudo kextunload "/usr/local/vscanx/Extensions/Virex.kext" 2>/dev/null

killvirex77process

}

virex861()
{
delete "/private/etc/cma.d/VSCANMAC8610"
}


virex86()
{
echo   "Cleaning Scheduled Tasks..."
sudo /usr/local/vscanx/VSCronCleaner 2>/dev/null

echo   "Removing VirusScan Application Folders..."
delete "/Applications/PreferencesApp.app"
delete "/Applications/VirusScan.app"
delete "/Applications/Utilities/VirusScan Schedule Editor.app"
delete "/etc/mach_init_per_user.d/virex_login.plist"
delete "/usr/local/vscanx"
delete "/usr/share/man/man1/uvscan.1"

echo "Removing VirusScan Support files..."
delete "/Library/LaunchDaemons/com.mcafee.virusscan.ScanManager.plist"
delete "/Library/LaunchDaemons/com.mcafee.virusscan.eupdate.plist"
delete "/Library/LaunchDaemons/com.mcafee.virusscan.VShieldEPOInterface.plist"
delete "/Library/LaunchAgents/com.mcafee.virusscan.VirusScanReporter.plist"

delete "/Library/Application Support/Virex/com.mcafee.virex.update_mod.plist"
delete "/Library/Application Support/Virex/com.mcafee.virex.eupdate.plist"
delete "/Library/Application Support/Virex/digest.plist"
delete "/Library/Application Support/Virex/.DS_Store"
sudo rm -rf "/Library/Application Support/Virex" 2>/dev/null

echo "Removing VirusScan Engine..." 

delete "/Library/Frameworks/AVEngine.framework"
delete "/Library/Frameworks/MacScanner.framework"
delete "/Library/Receipts/VirusScan.pkg"
delete "/Library/Frameworks/VirusScanPreferences.framework"
delete "/Library/Frameworks/ScanBooster.framework"
delete "/Library/NETASSOC/VSCANMAC8600"

echo "Removing VirusScan Support Documentation..."

delete "/Library/Documentation/Help/VirusScanHelp.help"

VAR=`dscl . -list /Groups | grep -w Virex`
if [ ! -z $VAR ]
then
echo "y" | sudo dseditgroup -o delete Virex > /dev/null
fi

echo "Cleaning up..."

if [ -x "/usr/local/vscanx/Extensions/Virex.kext" ]; then
	sudo rm -rf "/usr/local/vscanx/Extensions/Virex.kext"
fi

line=$(grep -n "VirusScan.log" /etc/syslog.conf | cut -d: -f1 | sed '1q')
if [ -n "$line" ]; then
sudo sed ${line}d /etc/syslog.conf > /tmp/syslog.new
sudo mv /tmp/syslog.new /etc/syslog.conf
sudo chown root /etc/syslog.conf
fi
}

virex851()
{
delete "/Library/Frameworks/VShieldHelper.framework"
delete "/Library/NETASSOC/VIREXUB_8501"
delete "/Library/StartupItems/Virex"
delete "/Library/StartupItems/VShieldEPOInterface"

if [ -x "/System/Library/Extensions/Virex.kext" ]; then
	sudo rm -rf "/System/Library/Extensions/Virex.kext"
fi
}

virex85()
{
delete  "/Library/NETASSOC/VIREXUB_8500"
}

virex80()
{
delete "/Library/NETASSOC/VRXMCTEL8000"
}

virex77()
{
 delete "/Applications/Virex.app"
 delete "/Applications/Utilities/Virex Schedule Editor.app"
 delete "/Library/NETASSOC/VIREX___7600"
 delete "/Library/NETASSOC/VIREX___7700"
 delete "/Library/NETASSOC/VRXMCTEL8500"
 delete "/Library/Receipts/Virex.pkg"
 delete "/Library/Documentation/Help/VirexHelp.help"
 delete "/usr/share/man/man1/VShieldStatus.1"

}

virex72()
{       delete "/Library/Application Support/Virex/VShieldExclude.txt"
	delete "/Applications/Virex 7"
	delete "/usr/local/share/man/man1/vscanx.1"
	delete "/Library/Documentation/Help/Virex Help"
	delete "/Library/Documentation/Help/Virex7.Help"
	delete "/Library/Documentation/Help/Virex 7.1 Help"
	delete "/Library/Documentation/Help/Virex 7.2 Help"
	delete "/Library/Documentation/Help/VirexHelp.help"
	delete "/Library/Receipts/Virex7.pkg"
	delete "/Library/Receipts/Virex 7.1.pkg"
	delete "/Library/Receipts/Virex 7.1 Trial.pkg"
	delete "/Library/Receipts/Virex 7.2.pkg"
	delete "$HOME/Library/Preferences/VirexPrefs.vprF"
	delete "${HOME}/Library/Preferences/com.nai.virex.plist"
	delete "${HOME}/Library/Preferences/com.nai.virex71.plist"
	delete "${HOME}/Library/Preferences/com.nai.virex72.plist"
 
}

StopVirexDaemons()
{
	sudo launchctl stop com.mcafee.virusscan.eupdate  2>/dev/null
	sudo launchctl stop com.mcafee.virusscan.VShieldEPOInterface  2>/dev/null
	sudo launchctl stop com.mcafee.virusscan.ScanManager  2>/dev/null
	
	#Close reporter for both type of instance running as a root and running as a normal user
	sudo launchctl stop com.mcafee.virusscan.VirusScanReporter  2>/dev/null
	launchctl stop com.mcafee.virusscan.VirusScanReporter  2>/dev/null
}

UnloadVirexDaemons()
{
	sudo launchctl unload /Library/LaunchDaemons/com.mcafee.virusscan.eupdate.plist  2>/dev/null
	sudo launchctl unload /Library/LaunchDaemons/com.mcafee.virusscan.VShieldEPOInterface.plist  2>/dev/null
	sudo launchctl unload /Library/LaunchDaemons/com.mcafee.virusscan.ScanManager.plist  2>/dev/null
	sudo launchctl unload /Library/LaunchAgents/com.mcafee.virusscan.VirusScanReporter.plist  2>/dev/null
	launchctl unload /Library/LaunchAgents/com.mcafee.virusscan.VirusScanReporter.plist  2>/dev/null
}

OldPreferenceDelete()
{
delete /Library/Preferences/com.nai.virex75.prefs.plist
#TODO add the other not supported pref files

}

# uninstaller is also used as preflight if number of input is greater than 2 then we can assume that uninstaller is called by preflight hence do not echo uninstall VirusScan for Mac 
if [ $# -lt 2 ] 
then
echo "VirusScan for Mac Uninstall"
echo "-------------------"
echo "This will uninstall VirusScan for Mac."
fi

usercheck=`id | grep uid=0 | wc -l`
if [ "$usercheck" -eq 0 ] ; then
echo " If you wish to proceed, authenticate below"
echo " or close this window if you wish to cancel."
fi
# sudo -k
sudo echo ""
val=$?
if [ $val -ne 0 ]
then
	echo "permission denied"
	exit -1
fi
if [ $# -lt 2 ]; then 
echo "Uninstalling VirusScan ..."
cd /
else
uninstallnwa
# uninstall nwa from our preflight
fi



# Stop all the daemons that are currently running
StopVirexDaemons

# Unloading  all the daemons that are currently running
UnloadVirexDaemons

# call kill process here #TODO Proper Shutdown
shutdownprocess

#killvirex77process

# delete files related to 8.6.1
virex861

# delete files related to 8.6
virex86

# delete files related to 8.5.1
virex851

# delete files related to 8.5
virex85

# delete files related to 8.0
virex80

# delete files related to 7.7
virex77

# delete files related to 7.2
virex72

# delete files related to old preferences
OldPreferenceDelete

if [ $# -lt 2 ]; then 
echo " "
echo "VirusScan has been successfully uninstalled."
fi
